/*  
Module : XCPTHLR.CPP
Purpose: DLL interface for the CExceptionLogger class
Created: PJN / 26-03-2003
History: None

Copyright (c) 2003 - 2012 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code. 

*/


/////////////////////// Includes //////////////////////////////////////////////

#include "stdafx.h"
#include "XCPTHLR.h"
#include "ExceptHandler.h"


/////////////////////// Macros / Defines / Locals /////////////////////////////

//The one and only instance of the crash handler
CExceptionLogger g_CrashHandlerLogger;


/////////////////////// Implementation ////////////////////////////////////////

BOOL __stdcall SetXCPTHLRFlags(DWORD dwFlags)
{
  g_CrashHandlerLogger.SetFlags(dwFlags);
  return TRUE;
}

DWORD __stdcall GetXCPTHLRFlags()
{
  return g_CrashHandlerLogger.GetFlags();
}

BOOL __stdcall SetXCPTHLRDirectory(LPCTSTR lpszDirectory)
{
  g_CrashHandlerLogger.SetDirectory(lpszDirectory);
  return TRUE;
}

LPCTSTR __stdcall GetXCPTHLRDirectory()
{
  return g_CrashHandlerLogger.GetDirectory();
}

void __stdcall XCPTHLRGenerateSampleException()
{
  g_CrashHandlerLogger.GenerateSampleException();
}