/*  
Module : XCPTHLR.H
Purpose: DLL interface for the CExceptionLogger class
Created: PJN / 26-03-2003
History: None

Copyright (c) 2003 - 2012 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code. 

*/

////////////////////////////// Macros / Defines ///////////////////////////////

#pragma once

#ifndef __XCPTHLR_H__
#define __XCPTHLR_H__

//constants to pass to SetXCPTHLRFlags
#define EXCEPTION_LOGGER_ENUMERATE_THREADS      0x00000001
#define EXCEPTION_LOGGER_ENUMERATE_MODULES      0x00000002
#define EXCEPTION_LOGGER_MODULE_SYMBOLS         0x00000004
#define EXCEPTION_LOGGER_REGISTERS              0x00000008
#define EXCEPTION_LOGGER_CALLSTACK              0x00000010
#define EXCEPTION_LOGGER_CALLSTACK_SYMBOLS      0x00000020
#define EXCEPTION_LOGGER_FILE_BUFFERING         0x00000040
#define EXCEPTION_LOGGER_RAW_CALLSTACK_CODE     0x00000100
#define EXCEPTION_LOGGER_RAW_CALLSTACK_STACK    0x00000200
#define EXCEPTION_LOGGER_ENUMERATE_PROCESSES    0x00000400
#define EXCEPTION_LOGGER_SYSTEM_DETAILS         0x00000800
#define EXCEPTION_LOGGER_ENVIRONMENT_STRINGS    0x00001000
#define EXCEPTION_LOGGER_DLL_VERSION_DETAILS    0x00002000
#define EXCEPTION_LOGGER_EXE_VERSION_DETAILS    0x00004000
#define EXCEPTION_LOGGER_MINIDUMP               0x00008000


////////////////////////////// Functions //////////////////////////////////////

extern "C"
{
  typedef BOOL (__stdcall SETXCPTHLRFLAGS)(DWORD);
  typedef SETXCPTHLRFLAGS* LPSETXCPTHLRFLAGS;

  BOOL __stdcall SetXCPTHLRFlags(DWORD dwFlags);

  typedef DWORD (__stdcall GETXCPTHLRFLAGS)();
  typedef GETXCPTHLRFLAGS* LPGETXCPTHLRFLAGS;

  DWORD __stdcall GetXCPTHLRFlags();

  typedef BOOL (__stdcall SETXCPTHLRDIRECTORY)(LPCTSTR);
  typedef SETXCPTHLRDIRECTORY* LPSETXCPTHLRDIRECTORY;

  BOOL __stdcall SetXCPTHLRDirectory(LPCTSTR lszDirectory);

  typedef LPCTSTR (__stdcall GETXCPTHLRDIRECTORY)();
  typedef GETXCPTHLRDIRECTORY* LPGETXCPTHLRDIRECTORY;

  LPCTSTR __stdcall GetXCPTHLRDirectory();

  typedef void (__stdcall XCPTHLRGENERATESAMPLEEXCEPTION)();
  typedef XCPTHLRGENERATESAMPLEEXCEPTION* LPXCPTHLRGENERATESAMPLEEXCEPTION;

  void __stdcall XCPTHLRGenerateSampleException();
};

#endif //__XCPTHLR_H__
